import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import PropTypes from 'prop-types';
import React from 'react';
import CircleX from '@s-ui/react-icons/lib/Circlex';
import cx from 'classnames';

var Tag = function Tag(_ref) {
  if (_ref === void 0) {
    _ref = {};
  }

  var _ref2 = _ref,
      Link = _ref2.Link,
      children = _ref2.children,
      url = _ref2.url,
      rest = _objectWithoutPropertiesLoose(_ref2, ["Link", "children", "url"]);

  return url ? React.createElement(Link, Object.assign({
    href: url
  }, rest), children) : React.createElement("span", rest, children);
};

var tagChipClassName = function tagChipClassName(_ref3) {
  var isClickable = _ref3.isClickable,
      _ref3$className = _ref3.className,
      className = _ref3$className === void 0 ? null : _ref3$className;
  return cx('sui-TagChip', className, {
    'sui-TagChip-link': isClickable
  });
};

var preventDefaultHandler = function preventDefaultHandler(handler) {
  return function (event) {
    return handler && (event.preventDefault(), event.stopPropagation(), handler.apply());
  };
};

var TagChip = function TagChip(_ref4) {
  var onRequestDelete = _ref4.onRequestDelete,
      onClick = _ref4.onClick,
      label = _ref4.label,
      url = _ref4.link,
      linkFactory = _ref4.linkFactory,
      className = _ref4.className,
      rel = _ref4.rel,
      _ref4$icon = _ref4.icon,
      Icon = _ref4$icon === void 0 ? CircleX : _ref4$icon;
  return React.createElement(Tag, {
    className: tagChipClassName({
      isClickable: url || onClick,
      className: className
    }),
    Link: linkFactory,
    onClick: preventDefaultHandler(onClick),
    rel: rel,
    url: url
  }, label, onRequestDelete && React.createElement("span", {
    onClick: preventDefaultHandler(onRequestDelete),
    className: "sui-TagChip-delete"
  }, React.createElement(Icon, {
    svgClass: "sui-TagChip-deleteIcon"
  })));
};

TagChip.displayName = 'TagChip';
TagChip.defaultProps = {
  linkFactory: function linkFactory(_ref5) {
    if (_ref5 === void 0) {
      _ref5 = {};
    }

    var _ref6 = _ref5,
        children = _ref6.children,
        rest = _objectWithoutPropertiesLoose(_ref6, ["children"]);

    return React.createElement("a", rest, children);
  } // eslint-disable-line

};
export default TagChip;